#include <minigui.ch>
#include <dbinfo.ch>

Function Main
   REQUEST DBFCDX , DBFFPT
   RDDSETDEFAULT( "DBFCDX" )

        Load Window Main
        Main.Center
        Main.Activate

Return


Function CreateCode()
	local mDbfName := Getfile ( { {'DBF Files','*.DBF'} } , 'Select DBF'), mAlias, aStruct := {}, i, mesg := "", mCdx := "", n
	main.label_1.value := mDbfName
	if empty(mDbfName)
		return nil
	endif
	mAlias := GetAlias(mDbfName)
	use &mDbfName alias &mAlias
	aStruct := dbstruct()
	mesg += "Function "+mAlias+"_Create()"
	mesg += CRLF+"LOCAL aDbf := {}, lCreateIndex := .F."
	for i := 1 to len(aStruct)
		mesg += CRLF
		mesg += "aadd(aDbf, {"+alltrim(aStruct[i, 1])
		mesg += ","+chr(9)+"'"+aStruct[i, 2]+"'"
		mesg += ","+chr(9)+str(aStruct[i, 3], 3, 0)
		mesg += ","+chr(9)+str(aStruct[i, 4], 2, 0)+"})"
	next
	mesg += CRLF+"if !file('"+mAlias+".dbf')"
	mesg += CRLF+chr(9)+"dbcreate('"+mAlias+"', aDbf)"
	mesg += CRLF+CHR(9)+"lCreateIndex := .T."
	mesg += CRLF+"endif"
	
	mCdx := GetCdx(mDbfName)
	
	if file(mCdx)
		mesg += CRLF+"if !file('"+mAlias+".cdx') .or. lCreateIndex"
		mesg += CRLF + chr(9) + "USE "+mAlias+" EXCLUSIVE"
		n := dborderinfo(DBOI_ORDERCOUNT)
		for i = 1 to n
			mesg += CRLF + chr(9) + "INDEX ON "+dborderinfo(DBOI_EXPRESSION,,i)+" TAG "+dborderinfo(DBOI_NAME,,i)
		next
		mesg += CRLF + chr(9) + "USE"
		mesg += CRLF + "endif"
	endif
	
	mesg += CRLF + "return nil"
	
	main.edit_1.value := mesg
	select &mAlias
	use
return nil


Function GetAlias(mDbfName)
	local mAlias := "", n := rat("\", mDbfName)
	mAlias := substr(mDbfName, n+1)
	n := rat(".", mAlias)
	if n > 0
		mAlias := substr(mAlias, 1, n-1)
	endif
	return (mAlias)

	
Function GetCdx(mDbfName)
	local mCdx := "", n := rat(".DBF", upper(mDbfName))
	if n > 0
		mCdx = substr(mDbfName, 1, n-1)+".CDX"
	endif
	return (mCdx)